/* FichothequeLib_Xml - Copyright (c) 2022-2023 Vincent Calame - Exemole
 * Logiciel libre donné sous triple licence :
 * 1) selon les termes de la CeCILL V2
 * 2) selon les termes de l’EUPL V.1.1
 * 3) selon les termes de la GNU GPLv3
 * Voir le fichier licences.txt
 */


package net.fichotheque.xml.extraction;

import java.util.function.Predicate;
import net.fichotheque.corpus.FicheMeta;
import net.fichotheque.extraction.ExtractionContext;


/**
 *
 * @author Vincent Calame
 */
public class ExtractParameters {

    private final ExtractionContext extractionContext;
    private final int extractVersion;
    private final boolean withEmpty;
    private final Predicate<FicheMeta> fichePredicate;

    public ExtractParameters(ExtractionContext extractionContext, int extractVersion, boolean withEmpty, Predicate<FicheMeta> fichePredicate) {
        this.extractionContext = extractionContext;
        this.extractVersion = extractVersion;
        this.withEmpty = withEmpty;
        this.fichePredicate = fichePredicate;
    }

    public ExtractionContext getExtractionContext() {
        return extractionContext;
    }

    public int getExtractVersion() {
        return extractVersion;
    }

    public boolean isWithEmpty() {
        return withEmpty;
    }

    public Predicate<FicheMeta> getFichePredicate() {
        return fichePredicate;
    }

    public ExtractParameters derive(Predicate<FicheMeta> fichePredicate) {
        return new ExtractParameters(extractionContext, extractVersion, withEmpty, fichePredicate);
    }

}
